#line 1
#line 28

package PPIx::Regexp::Token::Comment;

use strict;
use warnings;

use base qw{ PPIx::Regexp::Token };

our $VERSION = '0.026';

# Return true if the token can be quantified, and false otherwise
sub can_be_quantified { return };

sub significant {
    return;
}

sub comment {
    return 1;
}

# This must be implemented by tokens which do not recognize themselves.
# The return is a list of list references. Each list reference must
# contain a regular expression that recognizes the token, and optionally
# a reference to a hash to pass to make_token as the class-specific
# arguments. The regular expression MUST be anchored to the beginning of
# the string.
sub __PPIX_TOKEN__recognize {
    return ( [ qr{ \A \( \? \# [^\)]* \) }smx ] );
}

# We anticipate that these tokens will be generated by other classes:
# PPIx::Regexp::Token::Structure for parenthesized comments, and
# PPIx::Regexp::Token::Literal for end-of-line /x mode comments.

#line 74

1;

__END__

#line 101

# ex: set textwidth=72 :
